@REM Copyright (c) Microsoft Corporation. All rights reserved.
@REM ReACL.cmd <Root of AppService file share>
@REM This script must be run on the AppService file server, to reset the ACLs on the content share folders

@ECHO OFF
IF [%1]==[] (
  ECHO To ReACL stand alone file server, use: ReACL.cmd [File Share Root Directory]
  ECHO To ReACL domain joined file server, use: ReACL.cmd [File Share Root Directory] [Domain Name]
  GOTO :EOF
)

PUSHD %1
IF ERRORLEVEL 1 (
  ECHO Error switching to the share root
  GOTO :EOF
)

icacls . /reset
IF ERRORLEVEL 1 GOTO :EOF
icacls . /grant Administrators:(OI)(CI)(F)
IF ERRORLEVEL 1 GOTO :EOF
IF [%2]==[] (
  icacls . /grant "FileShareOwners:(OI)(CI)(M)"
) ELSE (
  icacls . /grant "%2\FileShareOwners:(OI)(CI)(M)"
)
IF ERRORLEVEL 1 GOTO :EOF
icacls . /inheritance:r
IF ERRORLEVEL 1 GOTO :EOF
IF [%2]==[] (
  icacls . /grant "FileShareUsers:(CI)(S,X,RA)"
) ELSE (
  icacls . /grant "%2\FileShareUsers:(CI)(S,X,RA)"
)
IF ERRORLEVEL 1 GOTO :EOF
icacls . /grant *S-1-1-0:(OI)(CI)(IO)(RA,REA,RD)
IF ERRORLEVEL 1 GOTO :EOF

FOR /D %%s IN (.\*) DO (
  IF NOT "%%s"==".\datasvcapi-versions" (
    FOR /D %%t IN (%%s\*) DO (
      icacls %%t /grant "*S-1-1-0:(OI)(CI)(M,DC)"
      IF ERRORLEVEL 1 GOTO :EOF
    )
  )
)
POPD

ECHO ReACL completed.
